org 0x1000   ; This code, is limitet to 17 sectors, version 0.04 optismed    ,
use32
mov bh,0x8f
mov edi,0xb800
mov esi,kernmsg
call print32msg 	    ;print strings
mov esi,ver
mov edi,0xb8320
call print32msg 	      ;  from the bootloader     to print strings
jmp coreloaded



ver: db "CUqE-OS Version: 0.04",0x0
kernmsg: db "The startcore has been loaded",0x0







coreloaded:
	;------------------------------------;
	;int catcher, hard- and software     ;
	;are  seperatede                    ;
	;************************************;
	xor eax,eax
	mov [0x8000], eax  ;



	jmp RdyIDT
	     idt_dptr:
	       .limit  dw ((idt_dend -idt_dstart ) * 48) -1 ; bits 0...15 is size of idt
	       .base   dd idt_dstart	   ; base of idt
	     RdyIDT:


		 lidt [idt_dptr]

		 sti
	   jmp splashscreen.prepare

print32msg:
	    cmp edi,0xb8000
	    jl msg32ediset
	    cmp edi,0xbffff
	    jg msg32ediset
	    xor bh,0x00
	    je msg32colorset
msgprint32:

	    mov al,[esi]
	    xor al,0x00
	    je print32finish
	    mov ah,bh
	    inc esi
	    mov [edi],ax
	    add edi,0x02
	    jmp msgprint32

msg32colorset:
	    mov bh,0x0f   ; default colour
	    jmp print32msg


msg32ediset:
	   mov edi,0xb8000
	   jmp print32msg

print32finish:
	   ret












defaulthardintmsg: db "hardware int",0x00
defaultintmsg: db "software int",0x00
;-----------------------------------;
; print function                    ;
;-----------------------------------;





   ;-------------;
   ;IDT Functions;
   ;-------------;  



idt_softdefault:


	     pusha
	     push gs
	     push fs
	     push es
	     push ds
	     push esp


	     mov esi,defaultintmsg
	     mov edi,0xb8128
	     mov bh,0x0f		    ;colour to print
	     call print32msg
	     ;get int nr. and inc

	     pop esp
	     pop ds
	     pop es
	     pop fs
	     pop gs
	     popa

	     iret

idt_harddefault:
	     pusha
	     push gs
	     push fs
	     push es
	     push ds
	     push esp


	     mov esi,defaulthardintmsg
	     mov edi,0xb8088
	     mov bh,0x0f		    ;colour to print
	     call print32msg
	     ;get int nr. and inc
	     mov al, 0x20		  ;Send EOI (end of interrupt)
	     out 0x20, al
	     pop esp
	     pop ds
	     pop es
	     pop fs
	     pop gs
	     popa

	     iret

splashscreen.prepare:
;----------------------;
;total clean the screen;
;----------------------;
	     call clean.screen
	     jmp kernel.start
	     ;jmp splashscreen.start
clean.screen:
	     mov edi,0xb8000
	     xor al,al
clean.screen.loop:
	     mov [edi],al
	     inc edi
	     cmp edi,0xbffff
	     jne clean.screen.loop
	     ret

splashscreen.start:

	     mov esi,menu.item1
	     call menu.function1

	     mov esi,menu.item2
	     call menu.function1

	     mov esi,menu.item3
	     call menu.function1

	     mov esi,menu.item4
	     call menu.function1

	     call menu.function3 ;start the menu





	     
	     


kernel.start:

	     call paging.start
	     call multitasking.start


	     sti
	     hlt





menu.item1: db "menu 1",0x00
menu.item2: db "menu 2",0x00
menu.item3: db "menu 3",0x00
menu.item4: db "menu 4",0x00
include 'kernel.asm'
include 'idt.asm'
include 'menu/menu.asm'