;----------------------------------------------------------------------;
;menu functions, version 0.1 beta                                      ;
;assumes pmode and a "printmsg32" function who prints a string         ;
;each string must end at "0x00" or else chage the code in function1    ;
;call function 1 for each menu item, you want                          ;
;                                                                      ;
;code type:32 bit                                                      ;
;memory changes: Yes, from 0x7000-0x8002                               ;
;use vido output:Yes                                                   ;
;use keybord: yes                                                      ;
;maker:KMTDK                                                           ;
;compiler: Fasm                                                        ;
;----------------------------------------------------------------------;
use32
;----------------------;
; function 1: print    ;
; input: esi:string     ;
; output: =>[0x7000]   ;
;----------------------;
menu.function1:
xor ax,ax
mov bx,0x7000

menu.function1.cmp1:
cmp ax,[bx]

je menu.function1.loop1

add bx,0x2
cmp bx,0x8000

je menu.function3 ; if we have too many strings, make the menu.
jmp menu.function1.cmp1; countinue to search

;-----loop, test where to store sting.^
menu.function1.loop1:
cmp bx,0x7000 ; if we dont have any string, start to write at 0x7000 insted of 0x7002. '
je menu.function1.loop1.write
add bx,0x2

menu.function1.loop1.write:
mov ax,[si]
mov [bx],ax
add si,0x2
add bx,0x2
cmp ax,0x00
jne menu.function1.loop1.write

;---------------------;
;function 1:  counter ;
;input: none          ;
;output: [0x8000]     ;
;menu height count    ;
;---------------------;
mov ax,[0x8000]
inc ax
mov [0x8000],ax
ret
;---------------------;
;funtion 3: mk menu   ;
;input: call function ;
;output: menu         ;
;when you press enter ;
;it will store the    ;
;marked menu nr,      ;
; at [0x8100]         ;
;---------------------;
menu.function3:
mov cx,[0x8000]
sub cx,0x1
mov bh,0x8f
mov esi,0x7000
mov edi,0xb8140
mov edx,edi
call print32msg       ; print the first sting, as marked


menu.function3.loop:
xor cx,0x00
je menu.function3.loop.finish	; if no more menu items exit
inc esi
mov bh,0xf0

add edx,0xa0
mov edi,edx

call print32msg
dec cx
jmp menu.function3.loop






menu.function3.loop.finish:
;--------------------------------------;
;read the ud and down arrow keys +enter;
;return the menu nr, when choosen      ;
;Using scancode 1                      ;
;--------------------------------------;
menu.read.keys:
in al,0x60
cmp al,0x1c	  ;chek for enter
je menu.choosen
cmp al,0x48	  ;chek for up arrow (the "8" key works also)
je menu.read.up
cmp al,0x50	  ;chek for down arrow (the "2" key works also)
je menu.read.down
jmp menu.read.keys

menu.choosen:

ret

menu.read.up:
mov cx,0x3
call menu.repaint
jmp menu.read.keys

menu.read.down:
mov cx,0x1
call menu.repaint
jmp menu.read.keys



menu.repaint:
ret
xor dx,dx	;counter 2
mov esi,0x6fff	;ajusteded for the command inc esi
mov edi,0xb8140
;mov edx,edi
push edi
menu.repaint.loop:
xor cx,0x00
inc esi
je menu.repaint.loop.finish   ; if no more menu items exit

mov bh,0xf0
pop edi
add edi,0xa0
push edi


call print32msg
inc dx
dec cx
jmp menu.repaint.loop

menu.repaint.loop.finish:
mov bh,0x8f	      ; marked item
call print32msg       ; print the marked sting, as marked
mov cx,[0x8000]       ; get the menu.height
pop edi
add edi,0xa0
push edi

menu.repaint.loop2:
cmp dx,cx	      ; have we reached the end ?
je menu.repaint.finish; if, return
inc esi
mov bh,0xf0
pop edi
add edi,0xa0
push edi
jmp menu.repaint.loop2



menu.repaint.finish:
ret

